;***************************************************************************
     TreeView_GetCount MACRO hWin
     invoke SendMessage,hWin,TVM_GETCOUNT,0,0
     ENDM
;***************************************************************************
     TreeView_DeleteItem MACRO hWin,item
     invoke SendMessage,hWin,TVM_DELETEITEM,0,item
     ENDM
;***************************************************************************
     TreeView_Expand MACRO hWin,item
     invoke SendMessage,hWin,TVM_EXPAND,TVE_EXPAND,item
     ENDM
;***************************************************************************
     TreeView_Collapse MACRO hWin,item
     invoke SendMessage,hWin,TVM_EXPAND,TVE_COLLAPSE,item
     ENDM
;***************************************************************************
     TreeView_GetItem MACRO hWin,item
     invoke SendMessage,hWin,TVM_GETITEM,0,item
     ENDM
;***************************************************************************
     TreeView_GetNextItem MACRO hWin,item
     invoke SendMessage,hWin,TVM_GETNEXTITEM,TVGN_CARET,item
     ENDM
;***************************************************************************
     TreeView_InsertItem MACRO hWin,tvinsertstruct
     invoke SendMessage,hWin,TVM_INSERTITEM,0,tvinsertstruct
     ENDM
;***************************************************************************
     TreeView_SelectItem MACRO hWin,item
     invoke SendMessage,hWin,TVM_SELECTITEM,TVGN_CARET,item
     ENDM
;***************************************************************************
     TreeView_SetImageList MACRO hWin
     invoke SendMessage,hWin,TVM_SETIMAGELIST,0,0
     ENDM
;***************************************************************************
     TreeView_SetItem MACRO hWin,tvitem
     invoke SendMessage,hWin,TVM_SETITEM,0,tvitem
     ENDM

;***************************************************************************
RGB macro red,green,blue
        xor eax,eax
        mov ah,blue
        shl eax,8
        mov ah,green
        mov al,red
endm
;***************************************************************************
      ALLOC MACRO bytecount
        invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,bytecount
        EXITM <eax>
      ENDM
;***************************************************************************
      free MACRO hmemory
        invoke GlobalFree,hmemory
      ENDM
;***************************************************************************
      chdir MACRO pathname
        invoke SetCurrentDirectory,reparg(pathname)
      ENDM
      CHDIR equ <chdir>
;***************************************************************************
      mkdir MACRO dirname
        invoke CreateDirectory,reparg(dirname),NULL
      ENDM
      MKDIR equ <mkdir>
;***************************************************************************
      rndir MACRO oldname,newname
        invoke MoveFile,reparg(oldname),reparg(newname)
      ENDM
      RNDIR equ <rndir>
;***************************************************************************
      rmdir MACRO dirname
        invoke RemoveDirectory,reparg(dirname)
      ENDM
      RMDIR equ <rmdir>
;***************************************************************************
      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM
;***************************************************************************
      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM
;***************************************************************************
      return MACRO arg
        mov eax, arg
        ret
      ENDM
;***************************************************************************
     DATATEXT MACRO Text:VARARG
       LOCAL dbText

     .DATA
     dbText BYTE Text,0
     .CODE
    ExitM < offset dbText >
    ENDM
;***************************************************************************
     FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM
;***************************************************************************
      LOWORD MACRO bigword  
        mov  eax,bigword
        and  eax,0FFFFh     ;; Set to low word 
      ENDM
;***************************************************************************
      HIWORD MACRO bigword  
        mov  eax,bigword
        and  eax,0FFFF0000h     ;; Set to low word 
        ror eax,16
      ENDM
;***************************************************************************
      COPYCAT MACRO Dest,Source1,Source2
            lea edi,Dest
            lea esi,Source1
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            lea esi,Source2
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            mov byte ptr [edi],0
      ENDM
;***************************************************************************
      STRINGLEN MACRO Source
            lea esi,Source
            mov edi,esi
  @@:       inc esi
            cmp byte ptr [esi],0
            jnz @B
            sub esi,edi
            mov eax,esi
      ENDM
;***************************************************************************
      STRINGCOPY MACRO Dest,Source
            lea edi,Dest
            lea esi,Source
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            mov byte ptr [edi],0      
      ENDM
;***************************************************************************
      STRINGCAT MACRO Dest,Source
            lea edi,Dest
  @@:       inc edi
            cmp byte ptr [edi],0
            jnz @B
            lea esi,Source
  @@:       mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            cmp byte ptr [esi],0
            jnz @B
            mov byte ptr [edi],0      
      ENDM
;***************************************************************************
      CAPSTRING MACRO Source
            mov esi,Source
    @@:     .if byte ptr [esi] >= 'a' && byte ptr [esi] <= 'z'
                sub byte ptr [esi],20h
            .endif
            inc esi
            .if byte ptr [esi] != 0
                jmp @B
            .endif
      ENDM
;***************************************************************************
      DECAPSTRING MACRO Source
            mov esi,Source
    @@:     .if byte ptr [esi] >= 'A' && byte ptr [esi] <= 'Z'
                add byte ptr [esi],20h
            .endif
            inc esi
            .if byte ptr [esi] != 0
                jmp @B
            .endif
      ENDM
;***************************************************************************
MSGLOOP MACRO msg
            

    StartLoop:
      invoke GetMessage,addr msg,NULL,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage,addr msg
      invoke DispatchMessage, addr msg
      jmp StartLoop
    ExitLoop:
      return msg.wParam
ENDM
;***************************************************************************
    ; ----------------------
    ; Switch/Case emulation
    ; ----------------------
    $casflg equ <>
    $casvar equ <>
    $casstk equ <>
    
    switch macro _var:req, _reg:=<eax>
        mov _reg, _var
        $casstk catstr <_reg>, <#>, $casflg, <#>, $casstk
        $casvar equ _reg
        $casflg equ <0>         ;; 0 = emit an .if, 1 an .elseif
    endm
    
    case macro _args:vararg     ;; like Pascal: case id1. id4 .. id8, lparam, ...
                                ;; does an or (case1 || case2 || case3...)
      $cas textequ <>
      irp $v, <_args>         ;; for each case
          t@ instr <$v>, <..> ;; range ?
          if t@               ;; yes
              $LB substr <$v>, 1, t@-1                  ;; lbound = left portion
              $LB catstr <(>, $casvar, <!>=>, $LB, <)>  ;; ($casvar >= lbound)
              $UB substr <$v>, t@+2                     ;; ubound = right portion
              $UB catstr <(>, $casvar, <!<=>, $UB, <)>  ;; ($casvar <= ubound)
              $t catstr <(>, $LB, <&&> , $UB,<)>        ;; (($casvar >= $lb) && ($casvar <= $ub))
          else    ;; no, it's a value (var/const)
              $t catstr <(>, $casvar, <==>, <$v>, <)>   ;; ($casvar == value)
          endif
          $cas catstr <|| >, $t, $cas                   ;; or this case w/ others
      endm
      $cas substr $cas, 3 ;; lose the extra "|| " in front
        ifidn $casflg, <0> ;; 0 = 1'st case
            % .if $cas ;; emit ".if"
        else ;; all others
            % .elseif $cas ;; emit ".elseif"
        endif
        $casflg equ <1> ;; NOT 1'st
    endm
    
    default macro _default:vararg
        .else
        _default
    endm
    
    endsw macro _cmd:vararg
        ifidn $casstk, <>
            .err <Endsw w/o Switch>
        else
            t@ instr $casstk, <#>
            $casvar substr $casstk, 1, t@-1
            $casstk substr $casstk, t@+1
            t@ instr $casstk, <#>
            $casflg substr $casstk, 1, t@-1
            ifidn $casstk, <#>
                $casstk equ <>
            else
                $casstk substr $casstk, t@+1
            endif
            .endif
        endif
    endm

  ; --------------------------------------------------
  ; equates for name and case variation in macro names
  ; --------------------------------------------------
    Case equ <case>
    CASE equ <case>
    Switch equ <switch>
    SWITCH equ <switch>

    Endsw equ <endsw>
    EndSw equ <endsw>
    ENDSW equ <endsw>

    Select equ <switch>
    select equ <switch>
    SELECT equ <switch>

    Endsel equ <endsw>
    endsel equ <endsw>
    ENDSEL equ <endsw>

    Default equ <default>
    DEFAULT equ <default>

    CaseElse equ <default>
    Caseelse equ <default>
    CASEELSE equ <default>
    caseelse equ <default>

